﻿//-----------------------------------------------------------------------
// <copyright file="DebugConsole.cs" company="Tigerware Development">
//     Copyright(c) Tigerware Development. All rights reserved.
// </copyright>
//-----------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ElexolIO24PTU.Net
{
    public partial class DebugConsole : Form
    {
        public bool AllowClose = false;

        public DebugConsole()
        {
            InitializeComponent();
        }

        public void WriteLine(string text)
        {
            if (this.Visible)
            {
                int length = textBox1.Text.Length;
                if (length > 2048)
                    textBox1.Text = textBox1.Text.Substring(length - 2048);

                textBox1.Text += text + "\r\n";
                textBox1.SelectionStart = textBox1.Text.Length;
                textBox1.ScrollToCaret();
            }
        }

        public void WriteLine(string format, params object[] args)
        {
            WriteLine(string.Format(format, args));
        }

        private void DebugConsole_FormClosing(object sender, FormClosingEventArgs e)
        {
            this.textBox1.Text = "";
            this.Visible = false;
            e.Cancel = !AllowClose;
        }
    }
}
